#include "dio_main.h"
/*
 * Field: Name, do_state, addr, di_num, do_num, gpio_method: superio/gpio, model_select
 */
/*
 * static dio_dev v2400 = {"v2400", 0, 0xf1, 4, 4, superio, 9};
 */
/* 
 * static dio_dev v2406 = {"v2400", 0, 0xf1, 6, 2, superio, 9};
 */
/*
 * For V2616A, IO port address is located at 0x304:  bit 0~1 =DO0~1  bit 2~7 = DI0~5.
 * For V2416A, IO port address is located at 0x305:  bit 0~5 =DI0~5  bit 6~7 = DO6~7.
 */
static dio_dev V2416A = {"V2416A", 0, 0x305, 6, 2, gpio, 9};

/* 
 * dio_inb() and dio_outb() -
 * call gpio or superio denpend on mdev->method, mdev->addr 
 * order is [do d1] 
 */

u8 V2416A_dio_inb(dio_dev* mdev)
{ 
	u8 val = 0;

	/* shift to hardware order: [di do] */

	if (mdev->method == superio) {
		val = superio_read(mdev->log_dev, mdev->addr);
	}
	else {
		val = inb(mdev->addr);
	}

	dp("dio_inb: %x\n", val);
	return val;
}

void V2416A_dio_outb(dio_dev* mdev) 
{ 
	if (mdev->method == superio) {
		superio_write(mdev->log_dev, mdev->addr,  mdev->do_state);
	}
       	else {
		dp("dio_outb: %x\n", mdev->do_state);
		outb(mdev->do_state, mdev->addr);
	}
}

dio_dev* moxa_platform_dio_init(void){

	// Register the SuperIO/GPIO inb()/outb() callback function
	register_dio_inb(V2416A_dio_inb);
	register_dio_outb(V2416A_dio_outb);

	printk("moxa-device-dio, %s: V2400A series  \n", __FUNCTION__);

	return &V2416A;
}

